<?php
/**
 * @version		$Id: edition.php,v 1.57 2010-11-06 23:15:55 juanca Exp $
 * @package		vpl. submission edition
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

global $CFG;
require_once dirname(__FILE__).'/../../../config.php';
require_once $CFG->libdir.'/formslib.php';
require_once $CFG->libdir.'/moodlelib.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';
require_once dirname(__FILE__).'/../editor/editor_utility.php';
require_once dirname(__FILE__).'/form.class.php';
global $CFG;
class mod_vpl_editor_form extends vpl_form {
	protected $vpl;
	protected $instance;
	function __construct($page,$vpl){
		$this->vpl = $vpl;
		$this->instance = $vpl->get_instance();
		parent::__construct($page,'mform1');
	}

	function normalize_filelist($requiredfilelist,$filelist){
		return array_values(array_unique(array_merge($requiredfilelist,$filelist)));
	}

	function definition(){
		global $USER;
		$this->vpl->require_capability(VPL_SUBMIT_CAPABILITY);
		$id = required_param('id',PARAM_INT);
		$userid = optional_param('userid',null,PARAM_INT);
		$this->addHidden('id',$id);
		if($userid){
			$this->addHidden('userid',$userid);
			$lastsub = $this->vpl->last_user_submission($userid);
		}
		else{
			$userid = $USER->id;
			$lastsub = $this->vpl->last_user_submission($userid);
		}
		$instance = $this->vpl->get_instance();
		$this->addHTML('<div style="text-align: center">');
		if($instance->example){ //Don't save
			$htmlAlertFilesChanged = 'onclick="vpl_setETarget();return true;"';
		}else{
			$htmlAlertFilesChanged = 'onclick="vpl_setETarget();return vpl_alertFilesChanged();"';
			$onClickStart = 'onclick="return vpl_action(\'';
			$onClickEnd = ')";';
			$strSave = get_string('save',VPL);
			$this->addSubmitButton('save',$strSave,
					$onClickStart.s($strSave).'\',true'.$onClickEnd);
		}
		$manager = $this->vpl->has_capability(VPL_MANAGE_CAPABILITY);
		if($instance->run || $manager){
			$text = get_string('run',VPL);
			if(!$instance->run){
				$text = '('.$text.')';
			}
			$this->addSubmitButton('run',$text,
					$onClickStart.s($text).'\',false'.$onClickEnd);
		}
		if($instance->debug || $manager){
			$text = get_string('debug',VPL);
			if(!$instance->debug){
				$text = '('.$text.')';
			}
			$this->addSubmitButton('debug',$text,
					$onClickStart.s($text).'\',false'.$onClickEnd);
		}
		if($instance->evaluate || $manager){
			$text = get_string('evaluate',VPL);
			if(!$instance->evaluate){
				$text = '('.$text.')';
			}
			$this->addSubmitButton('evaluate',$text,
					$onClickStart.s($text).'\',false'.$onClickEnd);
		}
		$linkBase = vpl_rel_url('edition.php','id', $id,'userid',$userid);
		if(optional_param('fullscreen',0,PARAM_INT)){
			$linkScreen = $linkBase;
			$linkSReset = vpl_url_add_param($linkBase,'fullscreen','1');
			$linkSReset = vpl_url_add_param($linkSReset,'resetfiles','1');
			$screenText = get_string('regularscreen',VPL);
		}else{
			$linkScreen = vpl_url_add_param($linkBase,'fullscreen','1');
			$linkSReset = vpl_url_add_param($linkBase,'resetfiles','1');
			$screenText = get_string('fullscreen',VPL);
		}
		$this->addHTML('&nbsp;<a href="'.$linkScreen.'">'.s($screenText).'</a>');
		$req_fgm = $this->vpl->get_required_fgm();
		if($req_fgm->is_populated() && !$instance->example){ //Reset files only if requested files has information
			$onclick ='onclick="return confirm(\''.s(get_string('sureresetfiles',VPL)).'\')"';
			$this->addHTML('&nbsp;|&nbsp;<a href="'.$linkSReset.'" '.$onclick.'>'.s(get_string('resetfiles',VPL)).'</a>');
		}
		$this->addHTML('</div>');
		//Generate editor
		$param_tags='';
		$req_filelist =$req_fgm->getFileList();
		if($lastsub && optional_param('resetfiles',0,PARAM_INT)==0){
			$submission = new mod_vpl_submission($this->vpl, $lastsub);
			$fgp =  $submission->get_submitted_fgm();
			$filelist = $this->normalize_filelist($req_filelist,$fgp->getFileList());
			$param_tags .= $submission->get_CE_parms();
		}else{
			$fgp =  $req_fgm;
			$filelist = $fgp->getFileList();
		}
		$nodisplay='style="display:none"';
		$max = $this->instance->maxfiles;
		$nf = count($filelist);
		for( $i = 0; $i < $max; $i++){
			$field_filename = 'filename'.$i;
			$field_filedata = 'filedata'.$i;
			if($i< $nf){
				$filename=$filelist[$i];
				$filedata=$fgp->getFileData($filelist[$i]);
				//TODO urlencode only onces
				$this->addHidden($field_filename,$filename);
				$this->addHidden($field_filedata,urlencode($filedata));
				$param_tags .= vpl_param_tag($field_filename,$filename);
				$param_tags .= vpl_param_tag($field_filedata,$filedata);
			}else{
				$this->addHidden($field_filename,'');
				$this->addHidden($field_filedata,'');
			}
		}
		$fontsize=get_user_preferences('vpl_fontsize',12);
		//Sanitize fontsize value
		if($fontsize <10 || $fontsize > 42){
			$fontsize = 12;
		}
		$this->addHidden('fontsize',$fontsize);
		$param_tags .= vpl_param_tag('fontsize',$fontsize,true);
		$req_fgm = $this->vpl->get_required_fgm();
		$req_filelist =$req_fgm->getFileList();
		$min = count($req_filelist);
		$param_tags .= vpl_editor_i18n::get_params_tag();
		$param_tags .= vpl_param_tag('minfiles',$min);
		$param_tags .= vpl_param_tag('maxfiles',$max);
		if($instance->restrictededitor){
			$param_tags .= vpl_param_tag('restrictededition');
		}
		if($instance->example){
			$param_tags .= vpl_param_tag('readonly');
		}
		$this->addHTML(vpl_get_editor_tag($param_tags));
		$this->addHTML(vpl_include_jsfile('editor.js'));
		//$mform->addElement('html',vpl_editor_i18n::add_jseditori18n(true));
		$i18n  = 'var vpl_changesNotSaved = "'.s(get_string('changesNotSaved',VPL)).'";';
		$i18n .= 'var vpl_fileNotChanged = "'.s(get_string('fileNotChanged',VPL)).'";';
		$i18n .= 'var vpl_filesNotChanged = "'.s(get_string('filesNotChanged',VPL)).'";';
		$i18n .= 'var vpl_filesChangedNotSaved = "'.s(get_string('filesChangedNotSaved',VPL)).'";';
		$i18n .= 'var vpl_maxFiles = '.$max.';';
		$this->addHTML(vpl_include_js($i18n));
		if(!$instance->example){
			$this->addHTML(vpl_include_js('vpl_installCloseCheck();',true));
		}
		$this->addHTML(vpl_include_js('vpl_initFiles();',true));
	}
	function display(){
		print_box_start();
		parent::display();
		print_box_end();
	}
}


$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
if(!$vpl->is_submit_able()){
	print_error('nopermissions');
}
$userid = optional_param('userid',FALSE,PARAM_INT);
if(!$userid || $userid == $USER->id){//Edit own submission
	$userid = $USER->id;
	$vpl->require_capability(VPL_SUBMIT_CAPABILITY);
	$vpl->network_check();
	$vpl->password_check();
}
else { //Edit other user submission
	$vpl->require_capability(VPL_MANAGE_CAPABILITY);
}
//TODO full screen edition link_to_popup_window()
$vpl->add_to_log('edit submission', vpl_rel_url('forms/edition.php','id',$id,'userid',$userid));
$mform = new mod_vpl_editor_form('edition_process.php',$vpl);
$fullscreen=optional_param('fullscreen',0,PARAM_INT);
$iframe='<div id="div_er" style="display: none"></div>';
if($fullscreen){
	$vpl->print_header_simple('onload = "vpl_resizeApplet();"');
	$user = get_record('user','id',$userid);
	$nav = build_navigation(fullname($user),$vpl->get_course_module());
	echo '<div class="navbar clearfix">';
	echo '<div class="breadcrumb">';
	echo $nav['navlinks'];
	echo '</div>';
	echo '</div>';
	$mform->display();
	echo $iframe;
}else{
	//Display page
	$vpl->print_header(get_string('edition',VPL),false,'onload = "vpl_resizeApplet();"');
	$vpl->print_view_tabs(basename(__FILE__));
	$mform->display();
	echo $iframe;
}
$vpl->print_footer_simple();
?>
