<?php
/**
 * @version		$Id: edition_process.php,v 1.29 2010-09-28 18:10:06 juanca Exp $
 * @package		vpl. process submission edition
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

global $CFG;
require_once dirname(__FILE__).'/../../../config.php';
require_once $CFG->libdir.'/formslib.php';
require_once $CFG->libdir.'/moodlelib.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission_CE.class.php';
require_once dirname(__FILE__).'/../vpl_example_CE.class.php';

$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
if(!$vpl->is_submit_able()){
	print_error('nopermissions');
}
$userid = optional_param('userid',FALSE,PARAM_INT);
if(!$userid || $userid == $USER->id){//Edit own submission
	$userid = $USER->id;
	$vpl->require_capability(VPL_SUBMIT_CAPABILITY);
}
else { //Edit other user submission
	$vpl->require_capability(VPL_MANAGE_CAPABILITY);
}

//Display page
$vpl->print_header(get_string('edition',VPL));
echo vpl_include_jsfile('transferResult.js');
echo "\n";
if($fontsize=optional_param('fontsize',FALSE)){
	set_user_preference('vpl_fontsize', $fontsize);
}
if(optional_param('save',FALSE)){
	if($userid != $USER->id){
		$vpl->require_capability(VPL_MANAGE_CAPABILITY);
	}
	mod_vpl_submission_CE::send_start_process(get_string('saving',VPL));
	$vpl->add_to_log('save submission', vpl_rel_url('forms/edition_process.php','id',$id,'userid',$userid));
	$files = array();
	$max = $vpl->get_instance()->maxfiles;
	for( $i = 0; $i < $max; $i++){
		$field_filename = 'filename'.$i;
		$field_filedata = 'filedata'.$i;
		if(isset($_POST[$field_filename]) && isset($_POST[$field_filedata])){
			$files[] = array('name' => $_POST[$field_filename],
						'data' =>urldecode(stripslashes($_POST[$field_filedata])));
		}
		mod_vpl_submission_CE::send_alive_to_editor();
	}
	$error='';
	if($vpl->pass_submission_restriction($files,$error)){
		//Create submission record
		//TODO Make code common with upload submission
		$submissiondata = new stdClass();
		$submissiondata->vpl = $vpl->get_instance()->id;
		$submissiondata->userid = $userid;
		$submissiondata->datesubmitted = time();
		$submissiondata->comments = '';
		$submissionid = insert_record('vpl_submissions',$submissiondata,TRUE);
		if(!$submissionid){
			$statusText=get_string('notsaved',VPL);
			vpl_js_alert($statusText);
			error('inserting vpl_submissions record');
			die;
		}
		//Save files
		$submission = new mod_vpl_submission($vpl,$submissionid);
		$submission->set_submited_file($files);
		$statusText=get_string('saved',VPL);
		print_box(get_string('saved',VPL));
		$vpl->delete_overflow_submissions($userid);
	}else{
		$statusText=get_string('notsaved',VPL);
		vpl_js_alert($error);
		print_box($error);
	}
	mod_vpl_submission_CE::send_end_process($statusText);
}
else if(optional_param('run',FALSE)){
	if($userid != $USER->id || !$vpl->get_instance()->run){
		$vpl->require_capability(VPL_GRADE_CAPABILITY);
	}
	$vpl->add_to_log('run', vpl_rel_url('forms/edition.php','id',$id,'userid',$userid));
	$subinstance = $vpl->last_user_submission($userid);
	if($subinstance !== false || $vpl->get_instance()->example){
		if($vpl->get_instance()->example){
			$submission=new mod_vpl_example_CE($vpl);
		}else{
			$submission=new mod_vpl_submission_CE($vpl,$subinstance);
		}
		$submission->send_start_process(get_string('running',VPL));
		$submission->run(0);
		$submission->send_end_process();
	}else{
		vpl_js_alert(get_string('nosubmission',VPL));
	}
}
else if(optional_param('debug',FALSE)){
	if($userid != $USER->id || !$vpl->get_instance()->debug){
		$vpl->require_capability(VPL_GRADE_CAPABILITY);
	}
	$vpl->add_to_log('debug', vpl_rel_url('forms/edition.php','id',$id,'userid',$userid));
	$subinstance = $vpl->last_user_submission($userid);
	if($subinstance !== false || $vpl->get_instance()->example){
		if($vpl->get_instance()->example){
			$submission=new mod_vpl_example_CE($vpl);
		}else{
			$submission=new mod_vpl_submission_CE($vpl,$subinstance);
		}
		$submission->send_start_process(get_string('debugging',VPL));
		$submission->run(1);
		$submission->send_end_process();
	}else{
		vpl_js_alert(get_string('nosubmission',VPL));
	}
}
else if(optional_param('evaluate',FALSE)){
	if($userid != $USER->id || !$vpl->get_instance()->evaluate){
		$vpl->require_capability(VPL_GRADE_CAPABILITY);
	}
	$vpl->add_to_log('evaluate', vpl_rel_url('forms/edition.php','id',$id,'userid',$userid));
	$subinstance = $vpl->last_user_submission($userid);
	if($subinstance !== false){
		$submission=new mod_vpl_submission_CE($vpl,$vpl->last_user_submission($userid));
		$submission->send_start_process(get_string('evaluating',VPL));
		$submission->evaluate();
		$submission->send_end_process();
	}else{
		vpl_js_alert(get_string('nosubmission',VPL));
	}
}
else{
	$vpl->add_to_log('error post', vpl_rel_url('forms/edition.php','id',$id,'userid',$userid));
	print_box('no acction');
}
$vpl->print_footer();
?>