<?php
/**
 * @version		$Id: listsimilarity.php,v 1.16 2010/06/18 20:07:17 juanca Exp $
 * @package		vpl. List most similar submission files 
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';
require_once dirname(__FILE__).'/similarity_factory.class.php';
require_once dirname(__FILE__).'/similarity_base.class.php';
require_once dirname(__FILE__).'/similarity_form.class.php';
require_once dirname(__FILE__).'/clusters.class.php';
require_once dirname(__FILE__).'/../views/status_box.class.php';
ini_set('memory_limit','256M');

$id = required_param('id', PARAM_INT);
$time_limit = 600; // 10 minutes
$vpl = new mod_vpl($id);
$vpl->require_capability(VPL_SIMILARITY_CAPABILITY);
$vpl->add_to_log('view similarity', vpl_rel_url('similarity/similarity_form.php','id',$id));
//Print header
$CFG->stylesheets[] = vpl_mod_href('similarity/similarity.css');
$vpl->print_header(get_string('listsimilarity',VPL));
$vpl->print_view_tabs(basename(__FILE__));
$form = new vpl_similarity_form('listsimilarity.php',$vpl);
if(!($fromform = $form->get_data())){
	print_error('readingdata',VPL);
}
//Get filelist names to scan
$filesselected=array();
$filelist = $vpl->get_required_fgm()->getFileList();
$num=0;
foreach($filelist as $filename){
	if(isset($fromform->{'file'.$num})){
		$filesselected[$filename]=true;
	}
	$num++;
}

$usernumber=0;
$nwm=0;
$simil = array();
//Preprocess current VPL instance
//TODO show the process and try to add time void set_time_limit  ( int $seconds  )
debugging("Adding activity files", DEBUG_DEVELOPER);
@set_time_limit($time_limit);
$activity_load_box = new vpl_progress_bar(s($vpl->get_instance()->name));
vpl_similarity::scan_activity($simil,$vpl,$filesselected,$activity_load_box);
debugging("Files to check ".count($simil), DEBUG_DEVELOPER);
$il = count($simil);
//Preprocess other VPL instance
if(isset($fromform->scanactivity) && $fromform->scanactivity>0){
	@set_time_limit($time_limit);
	$othervpl=new mod_vpl($fromform->scanactivity);
	$other_activity_load_box = new vpl_progress_bar(s($othervpl->get_instance()->name));
	debugging("Adding other activity files", DEBUG_DEVELOPER);
	vpl_similarity::scan_activity($simil,$othervpl,$filesselected,$other_activity_load_box);
	debugging("Files to check ".count($simil), DEBUG_DEVELOPER);
}
//Preprocess files in a ZIP file
if(isset($fromform->scanzipfile0) && $fromform->scanzipfile0>''){
	@set_time_limit($time_limit);
	$zip_load_box0 = new vpl_progress_bar(s($fromform->scanzipfile0));
	debugging("Adding files in zip file", DEBUG_DEVELOPER);
	vpl_similarity::scan_zip($simil,$fromform->scanzipfile0,$vpl,$filesselected,$zip_load_box0);
	debugging("Files to check ".count($simil), DEBUG_DEVELOPER);
}
if(isset($fromform->scanzipfile1) && $fromform->scanzipfile1>''){
	@set_time_limit($time_limit);
	$zip_load_box1 = new vpl_progress_bar(s($fromform->scanzipfile1));
	debugging("Adding files in zip file", DEBUG_DEVELOPER);
	vpl_similarity::scan_zip($simil,$fromform->scanzipfile1,$vpl,$filesselected,$zip_load_box1);
	debugging("Files to check ".count($simil), DEBUG_DEVELOPER);
}
//Preprocess files in a directory
if(isset($fromform->scandirectory) && $fromform->scandirectory>''){
	@set_time_limit($time_limit);
	$dir_load_box = new vpl_progress_bar(s($fromform->scandirectory));
	$basedir = $CFG->dataroot.'/'.$vpl->get_course()->id;
	debugging("Adding files in directory", DEBUG_DEVELOPER);
	vpl_similarity::scan_directory($simil,$fromform->scandirectory,$vpl,$filesselected,$dir_load_box);
	debugging("Files to check ".count($simil), DEBUG_DEVELOPER);
}
//Search similarity in other files after current VPL instance 
if(isset($fromform->searchotherfiles)){
	$il = count($simil);
}
@set_time_limit($time_limit);
$search_progression = new vpl_progress_bar(get_string('similarity',VPL));
$selected = vpl_similarity::get_selected($simil,$fromform->maxoutput,$il,$search_progression);

if(count($selected)){
	$firstname = get_string('firstname');
	$lastname  = get_string('lastname');
	if ($CFG->fullnamedisplay == 'lastname firstname') {
		$name = $lastname.' / '.$firstname;
	} else {
		$name = $firstname.' / '.$lastname;
	}
	$with	= get_string('similarto',VPL);
	$table = new stdClass();
	$table->head  = array ('#',$name, '',$with,get_string('numcluster',VPL,'#'));
	$table->align = array ('rigth','left', 'center', 'left','right');
	$table->size = array ('','60','60');
	$clusters = new vpl_clusters($selected);
	foreach($selected as $case){
		//Cluster assigning
		$clusters->process($case);
	}
	$clusters->assign_number();
	$usernumber=0;
	foreach($selected as $case){
		$table->data[] = array (++$usernumber,
							$case->first->show_info(),
							$case->get_link(),
							$case->second->show_info(),
							$case->get_cluster());
	}
	print_table($table);
	$clusters->print_clusters();
}
//Hide progress bars
$activity_load_box->hide();
if(isset($other_activity_load_box)){
	$other_activity_load_box->hide();
}
if(isset($zip_load_box0)){
	$zip_load_box0->hide();
}
if(isset($zip_load_box1)){
	$zip_load_box1->hide();
}
if(isset($dir_load_box)){
	$dir_load_box->hide();
}
$search_progression->hide();
$vpl->print_footer();
?>