<?php
/**
 * @version		$Id: similarity_java.class.php,v 1.1 2010/06/18 20:12:20 juanca Exp $
 * @package		vpl. C++ language similarity clases
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/similarity_c.class.php';

class vpl_similarity_java extends vpl_similarity_c{
	public function get_type(){
		return 3;
	}
	public function sintax_normalize(&$tokens){
		$open_brace =false;
		$nsemicolon=0;
		$ret = array();
		$prev = new vpl_token(vpl_token_type::identifier,'',0);
		foreach($tokens as $token){
			if($token->type == vpl_token_type::operator){
				//++ and -- operator
				//:: operator
				//(*p). and p->
				//+=, -=, *=, etc
				switch($token->value){
					case '[':
						//only add ]
						break;
					case '(':
						//only add )
						break;
					case '{':
						//only add }
						$nsemicolon=0;
						$open_brace =true;
						break;
					case '}':
						//Remove unneeded {}
						if(!($open_brace && $nsemicolon<2)){
							$ret[]=$token;
						}
						$open_brace =false;
						break;
					case ';':
						//count semicolon after a {
						$nsemicolon++;
						$ret[]=$token;
						break;
					case '++':
						$token->value='=';
						$ret[]=$token;
						$token->value='+';
						$ret[]=$token;
						break;
					case '--':
						$token->value='=';
						$ret[]=$token;
						$token->value='-';
						$ret[]=$token;
						break;
					case '+=':
						$token->value='=';
						$ret[]=$token;
						$token->value='+';
						$ret[]=$token;
						break;
					case '-=':
						$token->value='=';
						$ret[]=$token;
						$token->value='-';
						$ret[]=$token;
						break;
					case '*=':
						$token->value='=';
						$ret[]=$token;
						$token->value='*';
						$ret[]=$token;
						break;
					case '/=':
						$token->value='=';
						$ret[]=$token;
						$token->value='/';
						$ret[]=$token;
						break;
					case '%=':
						$token->value='=';
						$ret[]=$token;
						$token->value='%';
						$ret[]=$token;
						break;
					case '.':
						if($prev->value == 'this'){
							break;
						}
					case '::':
						break;
					default:
						$ret[]=$token;
				}
				$prev=$token;
			}
			//TODO remove (p)
		}
		return $ret;
	}
	
	public function get_tokenizer(){
		return vpl_tokenizer_factory::get('java');
	}
}

?>