<?php
/**
 * @version		$Id: view.php,v 1.29 2010-07-26 11:21:10 juanca Exp $
 * @package		vpl. Show a vp instance
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../config.php';
require_once dirname(__FILE__).'/locallib.php';
require_once dirname(__FILE__).'/vpl.class.php';
global $CFG;
$id = optional_param('id', null	, PARAM_INT); // Course Module ID, or
//$a  = optional_param('a', null, PARAM_INT);  // vpl ID
$vpl = new mod_vpl($id);
$vpl->require_capability(VPL_VIEW_CAPABILITY);
$cm = $vpl->get_course_module();
$log_url=vpl_rel_url('view.php','id',$cm->id);
if(!$vpl->is_visible()){
	$vpl->add_to_log('view', $log_url, "not show");
	notice(get_string('notavailable'));
}
if(!$vpl->has_capability(VPL_MANAGE_CAPABILITY) &&
   !$vpl->has_capability(VPL_GRADE_CAPABILITY)){
   	$vpl->network_check();
	$vpl->password_check();
	$userid=$USER->id;
}else{
	$userid=optional_param('userid', $USER->id, PARAM_INT);
}
$vpl->add_to_log('view', $log_url);
// Print the page header
$CFG->stylesheets[] = vpl_mod_href('views/sh.css');
$vpl->print_header(get_string('description',VPL),true);

/// Print the main part of the page
$vpl->print_view_tabs(basename(__FILE__));
$vpl->print_name();
$vpl->print_submission_period();
$vpl->print_submission_restriction();
$vpl->print_variation($userid);
$vpl->print_fulldescription();
$vpl->get_required_fgm()->print_files(false);
/// Finish the page
$vpl->print_footer();
?>
